package com.brainoff { 
	
	import flash.display.MovieClip;
	public class worldkitMain {
	    static public var version:String = "3.3-20070820";
	
	    public var conf:worldkitConfig;
	    public var img:worldkitImages;
	    public var interact:worldkitInteraction;
	    public var rss:worldkitRSS;
	
	    public var parent:MovieClip;
	
	    public function worldkitMain () { }
	
	    public function main(parent):void {
		this.parent = parent; 
	
		worldkitUtil.setUp();
	
		conf = new worldkitConfig(this);
		img = new worldkitImages(this);
		interact = new worldkitInteraction(this);
		rss = new worldkitRSS(this);
	
		conf.load();
	    }
	
	    /*
	      Controls loading order of config, images, rss
	    */
	    public function signalDone(sig:String) {
		switch (sig) {
		case "CONFIG":
		    interact.afterConf();
		    img.load();
		    interact.SetupInput();
		    break;
		case "IMAGES":
		    worldkitGPX.start(this);
		    rss.start();
		    if (conf.onloadcallback) {
			interact.processClick("","_"+conf.onloadcallback,"");
		    }
		    break;
		default:
		    break;
		}
	    }
	
	    /*
	      classes request access to other classes through worldkitMain
	    */
	    public function getConfig():worldkitConfig {
		return conf;
	    }
	    public function getInteract():worldkitInteraction {
		return interact;
	    }
	    public function getRSS():worldkitRSS {
		return rss;
	    }
	    public function getImages():worldkitImages {
		return img;
	    }
	}
	
}